<template>
  <div class="sw-gs-searchbar-actions">
    <SfSearchBar
      :placeholder="$t('Search for products')"
      :aria-label="$t('Search for products')"
      :value="ilSearchTerm"
      class="sw-gs-il-searchbar"
      @input="performSuggestSearch"
    />
  </div>
</template>

<script>
  import {SfSearchBar} from "@storefront-ui/vue";
  import {debounce} from "lodash";
  import {useInstantListing} from "../../logic/composables/useInstantListing";

  export default {
    name: "SwGsIlSearchBar",
    components: {
      SfSearchBar
    },
    setup() {
      const {
        getSearchedProducts,
        loadAllProductData,
        ilSearchTerm
      } = useInstantListing();

      const performSuggestSearch = debounce((searchTerm) => {
        if (searchTerm.length > 0) {
          getSearchedProducts(searchTerm);
        } else {
          loadAllProductData(true);
        }
      }, 700);

      return {
        performSuggestSearch,
        ilSearchTerm
      }
    }
  }
</script>
<style lang="scss" scoped>

  .sw-gs-searchbar-actions {
    display: flex;
    flex-direction: row;
    justify-content: space-between;

    .sw-gs-il-searchbar {
      width: 100%;
    }

  }

</style>
